using System;
using System.Collections;
using System.Text;
using System.Diagnostics;

using Cosmos.UserFrame;
using Cosmos.ServiceProvider;
using Cosmos.Common;
using Cosmos.CommonManager;
using System.Data;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.IO;
using Cosmos.BaseFrame;

/*-----------------------------------------------------------------------------------------------*/
// 설      명 : 중국 알리페이/위챗페이
// 작  성  자 : 
// 변경  이력 : 
/*-----------------------------------------------------------------------------------------------*/
namespace Cosmos.Service
{
    class WeChatPay : PaymentBase, IPaymentUs
    {
        private INetworkJSON m_cNetworkJson;


        public WeChatPay()
        {
            m_cNetworkJson = (INetworkJSON)sManager.InitServiceInstance(ServiceLists.AGENT_NETWORK.DLL, ServiceLists.AGENT_NETWORK.NETWORK_JSON);
        }

        #region SearchPayment 결제 조회
        /// <summary>
        /// 결제 조회
        /// </summary>
        /// <param name="aParam"></param>
        /// <param name="aRet"></param>
        /// <returns></returns>
        public string SearchPayment(string[] aParam, ref string[] aRet)
        {
            string sRet = UserCom.RST_ERR;

            try
            {
                
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region GetPayment 결제 정보 획득
        /// <summary>
        /// 결제 정보 획득
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public object GetPayment(string[] aParam)
        {
            return m_cPayItem;
        }
        #endregion

        #region SetPayment 결제 등록
        /// <summary>
        /// 결제 등록
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string SetPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sPosMenuKey = "", sInPutType = "", sInPutData = "", sInEncData = "";

            try
            {
                sPosMenuKey = aParam[0];                     // 메뉴키
                sInPutType = aParam[1];                      // 입력구분
                sInPutData = aParam[2];                      // 입력데이터
                sInEncData = aParam[3];                      // 카드데이터
                double nPayAmt = CmUtil.DoubleParse(aParam[4]);     // 대상금액

                m_cPayItem = new Column.TR_PAYMENT.DATA();      // 결과 저장 변수 생성

                m_cPayItem.PAY_WAY_CD = GetMenuKeyToPayWayCd(sPosMenuKey);
                m_cPayItem.PAY_DTL_CD_01 = GetMenuKeyToPayDtlCd(sPosMenuKey);

                if (sInPutData.StartsWith("28") == true)
                {
                    m_cPayItem.PAY_DTL_CD_01 = ItemConst.TR_ITEM_ID.PAY.ALIPAY_PAY;    //알리페이
                }
                // #Rhee, 20170922 중국 은련페이 추가 start
                else if (sInPutData.StartsWith("62") == true)
                {
                    m_cPayItem.PAY_DTL_CD_01 = ItemConst.TR_ITEM_ID.PAY.UNION_PAY;      //은련(유니온)페이
                }
                // #Rhee, 20170922 중국 은련페이 추가 end

                sRet = ExecuteIrt(PosConst.CANCEL_DIV.NORMAL, ItemConst.WECHATPAY_TRAN_TYPE.APPROVE, sInPutType, sInPutData, sInEncData, nPayAmt, "", "", "", "");
                if (sRet != UserCom.RST_OK) return sRet;

                // 결제 아이템 추가
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);     // 결제 내역 받아 오기
                m_cPayItem.SEQ = alPayItem.Count + 1;
                alPayItem.Add(m_cPayItem);

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region CancelPayment 결제 취소
        /// <summary>
        /// 결제 취소
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string CancelPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "";

            try
            {
                if (m_cTrnStatus.Head.TradeDiv != ItemConst.TRAN_DIV.NORMAL) return sRet;

                //LS_ApprDeamon(false);

                int nPayRow = CmUtil.IntParse(aParam[0]);               // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                sInPutType = m_cPayItem.OCCUR_ENTRY_05;                 // 입력구분
                sInPutData = m_cPayItem.OCCUR_ENTRY_01;                 // 입력데이터
                sInEncData = m_cPayItem.CanFiller1;                     // 카드데이터

                double nPayAmt = m_cPayItem.AMT_ENTRY_01;               // 대상금액
                string sApprDate = m_cPayItem.OCCUR_ENTRY_03;           // 승인일자
                string sApprNo = m_cPayItem.OCCUR_ENTRY_02;             // 승인번호
                string sOrdTransID = m_cPayItem.OCCUR_ENTRY_09;         // 원거래번호
                string sOrgPayID = m_cPayItem.OCCUR_ENTRY_10;           // 원결제구분

                // 취소시 카드번호 대신 '0000' + 승인번호로 대체하여 요청해야 취소 가능
                sInEncData = "0000" + sApprNo;
                sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, ItemConst.WECHATPAY_TRAN_TYPE.REFUND, sInPutType, sInPutData, sInEncData, nPayAmt, sApprDate, sApprNo, sOrdTransID, sOrgPayID);
                if (sRet != UserCom.RST_OK) return sRet;

                m_cPayItem.CANCEL_DIV = PosConst.CANCEL_DIV.CANCEL;

                m_cDataService.UpdatePluAmount();       // 상품 합계금액 계산(거래해더)
                m_cDataService.UpdatePayAmount();       // 결제 금액 재 계산 처리

                //WinManager.ConfirmMessage(sPointType + " " + MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0068));
                // 여전법 대응 ///////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref m_cPayItem.CanFiller1);
                //////////////////////////////////////////////////////////////////////////////////

                //LS_ApprDeamon(true);
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region RefundPayment 결제 반품
        /// <summary>
        /// 결제 반품
        /// </summary>
        /// <param name="aParam"></param>
        /// <returns></returns>
        public string RefundPayment(string[] aParam)
        {
            string sRet = UserCom.RST_ERR;
            string sInPutType = "", sInPutData = "", sInEncData = "";

            try
            {
                //LS_ApprDeamon(false);

                int nPayRow = CmUtil.IntParse(aParam[0]); // 취소할 행번호

                // 결제 내역 받아 오기
                ArrayList alPayItem = (ArrayList)StateObject.GetItemObject(Column.TR_PAYMENT.ITEM);
                m_cPayItem = (Column.TR_PAYMENT.DATA)alPayItem[nPayRow];

                sInPutType = m_cPayItem.OCCUR_ENTRY_05;                 // 입력구분
                sInPutData = m_cPayItem.OCCUR_ENTRY_01;                 // 입력데이터
                sInEncData = m_cPayItem.CanFiller1;                     // 카드데이터

                double nPayAmt = m_cPayItem.AMT_ENTRY_01;               // 대상금액                
                // #Rhee, 20171218 중국 페이결제 할인내역 반품 수정 Start
                // 추가
                if ((m_cPayItem.OCCUR_ENTRY_10 == "10001") || (m_cPayItem.OCCUR_ENTRY_10 == "10004") || (m_cPayItem.OCCUR_ENTRY_10 == "10031"))             
                // 원결제구분 (10001:알리페이, 10004:위챗페이, 10031:은련 페이)
                {
                    nPayAmt = m_cPayItem.AMT_ENTRY_02 > 0 ? m_cPayItem.AMT_ENTRY_01 + m_cPayItem.AMT_ENTRY_02 : m_cPayItem.AMT_ENTRY_01;     // 대상금액
                }
                // #Rhee, 20171218 중국 페이결제 할인내역 반품 수정 End

                string sApprDate = m_cPayItem.OCCUR_ENTRY_03;           // 승인일자
                string sApprNo = m_cPayItem.OCCUR_ENTRY_02;             // 승인번호
                string sOrdTransID = m_cPayItem.OCCUR_ENTRY_09;         // 원거래번호
                string sOrgPayID = m_cPayItem.OCCUR_ENTRY_10;           // 원결제구분

                if (m_cPayItem.OCCUR_ENTRY_08.ToString() != ItemConst.PAY_APP_DIV.NORMAL)
                {
                    //임의 등록 이면 승인 없이 데이터 처리
                    //WinManager.ConfirmMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0240));
                    m_cPayItem.OCCUR_ENTRY_06 = m_cPayItem.OCCUR_ENTRY_02;
                    m_cPayItem.OCCUR_ENTRY_07 = m_cPayItem.OCCUR_ENTRY_03;
                }
                else
                {
                    // 취소시 카드번호 대신 '0000' + 승인번호로 대체하여 요청해야 취소 가능
                    sInEncData = "0000" + sApprNo;
                    sRet = ExecuteIrt(PosConst.CANCEL_DIV.CANCEL, ItemConst.WECHATPAY_TRAN_TYPE.REFUND, sInPutType, sInPutData, sInEncData, nPayAmt, sApprDate, sApprNo, sOrdTransID, sOrgPayID);
                    if (sRet != UserCom.RST_OK) return sRet;
                }                

                // 여전법 대응 ///////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref m_cPayItem.CanFiller1);
                //////////////////////////////////////////////////////////////////////////////////

                //LS_ApprDeamon(true);
                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                //////////////////////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                CmUtil.ZeroFillClear(ref aParam);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion

        #region SetMenualPayment
        public string SetMenualPayment(string[] aParam)
        {
            throw new NotImplementedException();
        }
        #endregion

        #region 조회
        /// <summary>
        /// 조회
        /// </summary>
        public string ExecuteIrt(string sTradeDiv, string sTrType, string sInPutType, string sInPutData, string sInEncData, double nPayAmt, string sApprDate, string sApprNo, string sOrdTransID, string sOrgPayID)
        {
            string sRet = UserCom.RST_ERR;
            string sTransID = DateTime.Now.ToString("HHmmssfff");

            try
            {
                // 연습모드이면 연습 데이터 설정
                if (m_cPosStatus.Base.TrainingFlag == "1" || m_cPosStatus.Mst.TestStorYn == "1") return SetTrainingData(sTradeDiv, sTrType, sInPutType, sInPutData, sInEncData, nPayAmt, sApprDate, sApprNo, sTransID, sOrdTransID, sOrgPayID);

                // 승인업체 코드 조회
                string sVanCD = PosMstManager.GetMstPayDc(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);
                //if (sVanCD == "")
                //{
                //    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0563);
                //    return sRet;
                //}

                // 포인트 조회,사용,사용취소
                Hashtable htRecvData = new Hashtable();
                sRet = ExecuteJsonIrt(sTradeDiv, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sVanCD, sTrType, sInPutType, sInPutData, sInEncData, nPayAmt, sTransID, sOrdTransID, sApprNo, sOrgPayID, ref htRecvData);
                if (sRet != UserCom.RST_OK) return sRet;

                m_cPayItem.PAY_AMT = nPayAmt;

                m_cPayItem.PAY_DTL_CD_02 = "";                                                                      // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "";
                m_cPayItem.PAY_DTL_CD_04 = "";
                m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.PAY;                                                // 할인결제구분 (1:결제, 2:할인)

                m_cPayItem.AMT_ENTRY_01 = nPayAmt;                                                                  // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;                                                                        // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = 0;
                m_cPayItem.AMT_ENTRY_04 = 0;
                m_cPayItem.AMT_ENTRY_05 = 0;
                m_cPayItem.AMT_ENTRY_06 = 0;
                m_cPayItem.AMT_ENTRY_07 = 0;
                m_cPayItem.AMT_ENTRY_08 = 0;
                m_cPayItem.AMT_ENTRY_09 = 0;
                m_cPayItem.AMT_ENTRY_10 = 0;

                m_cPayItem.OCCUR_ENTRY_01 = sInPutData;                                                             // 카드번호
                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                    m_cPayItem.OCCUR_ENTRY_02 = htRecvData["pay_transId"].ToString().Trim();                        // 승인번호
                else
                    m_cPayItem.OCCUR_ENTRY_02 = sApprNo;
                m_cPayItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyyyMMdd");                                      // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmmss");                                        // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sInPutType;                                                             // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                                                                // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                                                              // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;                                           // 승인구분

                // #Rhee, 20171211 중국 페이결제 할인내역 추가 Start
                // 기존
                //if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                //{
                //    m_cPayItem.OCCUR_ENTRY_09 = sTransID;                                                           // 전송번호
                //    m_cPayItem.OCCUR_ENTRY_10 = htRecvData["pay_ebcode"].ToString().Trim();                         // 결제구분 (10001:알리페이, 10004:위챗페이, 10031:은련 페이(Rhee, 2017/09/04))
                //}
                // 변경                
                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    int nCouponAmount = 0;
                    int nTotalAmount = Convert.ToInt32(htRecvData["total_amount"].ToString().Trim());
                    if (htRecvData.Contains("mcoupon_amount"))
                    {
                        nCouponAmount = htRecvData["mcoupon_amount"].ToString().Trim() != "" ? Convert.ToInt32(htRecvData["mcoupon_amount"].ToString().Trim()) : 0;
                    }
                    if (htRecvData.Contains("pcoupon_amount"))
                    {
                        nCouponAmount = nCouponAmount + (htRecvData["pcoupon_amount"].ToString().Trim() != "" ? Convert.ToInt32(htRecvData["pcoupon_amount"].ToString().Trim()) : 0);
                    }

                    if (nCouponAmount > 0)
                    {
                        nTotalAmount = nTotalAmount - nCouponAmount;
                        //m_cPayItem.AMT_ENTRY_01 = Convert.ToDouble(htRecvData["alipay_amount"].ToString()) * 0.01;      // 사용포인트                , Rhee, 20171212
                        m_cPayItem.AMT_ENTRY_01 = Convert.ToDouble(nTotalAmount) * 0.01;                                // 할인 제외금액              , Rhee, 20180112
                        m_cPayItem.AMT_ENTRY_02 = nCouponAmount * 0.01;                                                 // 제휴 할인 금액             , Rhee, 20171212
                    }                    
                    m_cPayItem.OCCUR_ENTRY_09 = sTransID;                                                               // 전송번호
                    m_cPayItem.OCCUR_ENTRY_10 = htRecvData["pay_ebcode"].ToString().Trim();                             // 결제구분 (10001:알리페이, 10004:위챗페이, 10031:은련 페이(Rhee, 2017/09/04))
                }
                // #Rhee, 20171211 중국 페이결제 할인내역 추가 End
                else
                {
                    m_cPayItem.OCCUR_ENTRY_09 = sOrdTransID;                                                            // 원전송번호
                    m_cPayItem.OCCUR_ENTRY_10 = sOrgPayID;                                                              // 원결제구분 (10001:알리페이, 10004:위챗페이, 10031:은련 페이)
                }
                m_cPayItem.OCCUR_ENTRY_11 = "";
                m_cPayItem.OCCUR_ENTRY_12 = "";
                m_cPayItem.OCCUR_ENTRY_13 = "";
                m_cPayItem.OCCUR_ENTRY_16 = sVanCD;              // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                //m_cPayItem.CanFiller1 = sCardData;

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;              // 빌분리 번호

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }

        /// <summary>
        /// 연습 데이터 설정
        /// </summary>
        public string SetTrainingData(string sTradeDiv, string sTrType, string sInPutType, string sInPutData, string sCardData, double nPayAmt, string sApprDate, string sApprNo, string sTransID, string sOrdTransID, string sOrgPayID)
        {
            string sRet = UserCom.RST_ERR;
            try
            {
                // 연습모드이면 연습 데이터 설정

                // 결제구분 (1:결제, 2:할인)
                DataRow dr = PosMstManager.GetMstPayDc(new string[] { m_cPosStatus.Base.CmpCd, m_cPosStatus.Base.StoreNo, m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01 });

                m_cPayItem.PAY_AMT = nPayAmt;

                m_cPayItem.PAY_DTL_CD_02 = "";                                  // 캠페인코드
                m_cPayItem.PAY_DTL_CD_03 = "";
                m_cPayItem.PAY_DTL_CD_04 = "";
                m_cPayItem.PAY_DTL_CD_05 = PosConst.PAY_DC_TYPE.PAY;            // 할인결제구분 (1:결제, 2:할인)

                m_cPayItem.AMT_ENTRY_01 = nPayAmt;                              // 사용포인트
                m_cPayItem.AMT_ENTRY_02 = 0;                                    // 제휴 할인 금액
                m_cPayItem.AMT_ENTRY_03 = 0;                                    // 총포인트
                m_cPayItem.AMT_ENTRY_04 = 0;                                    // 가용포인트
                m_cPayItem.AMT_ENTRY_05 = 0;                                    // 잔여포인트
                m_cPayItem.AMT_ENTRY_08 = 0;

                m_cPayItem.OCCUR_ENTRY_01 = sInPutData;                         // 카드번호
                m_cPayItem.OCCUR_ENTRY_02 = "99999999";                         // 승인번호
                m_cPayItem.OCCUR_ENTRY_03 = DateTime.Now.ToString("yyMMdd");    // 승인일자
                m_cPayItem.OCCUR_ENTRY_04 = DateTime.Now.ToString("HHmmss");    // 승인시간
                m_cPayItem.OCCUR_ENTRY_05 = sInPutType;                         // 입력 구분
                m_cPayItem.OCCUR_ENTRY_06 = sApprNo;                            // 원승인번호
                m_cPayItem.OCCUR_ENTRY_07 = sApprDate;                          // 원승인일자
                m_cPayItem.OCCUR_ENTRY_08 = ItemConst.PAY_APP_DIV.NORMAL;       //승인구분

                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    m_cPayItem.OCCUR_ENTRY_09 = sTransID;                       // 전송번호

                    // #Rhee, 20170922 중국 은련페이 추가 start
                    // 기존
                    //if (CmUtil.LeftH(sInPutData, 2) == "13")
                    //    m_cPayItem.OCCUR_ENTRY_10 = "10004";                    // 결제구분 (10001:알리페이, 10004:위챗페이, )
                    //else
                    //    m_cPayItem.OCCUR_ENTRY_10 = "10001";
                    // 변경
                    if (CmUtil.LeftH(sInPutData, 2) == "13")
                    {
                        m_cPayItem.OCCUR_ENTRY_10 = "10004";                     // 결제구분 (10001:알리페이, 10004:위챗페이, 10031:은련 페이(Rhee, 2017/09/04))
                    }
                    else if (CmUtil.LeftH(sInPutData, 2) == "62")
                    {
                        m_cPayItem.OCCUR_ENTRY_10 = "10031";                     // 결제구분 (10001:알리페이, 10004:위챗페이, 10031:은련 페이(Rhee, 2017/09/04))
                    }                        
                    else
                    {
                        m_cPayItem.OCCUR_ENTRY_10 = "10001";
                    }                       
                    // #Rhee, 20170922 중국 은련페이 추가 end
                }
                else
                {
                    m_cPayItem.OCCUR_ENTRY_09 = sOrdTransID;                    // 원전송번호
                    m_cPayItem.OCCUR_ENTRY_10 = sOrgPayID;                      // 원결제구분 (10001:알리페이, 10004:위챗페이)
                }
                m_cPayItem.OCCUR_ENTRY_11 = "";
                m_cPayItem.OCCUR_ENTRY_12 = "";
                m_cPayItem.OCCUR_ENTRY_13 = "";
                m_cPayItem.OCCUR_ENTRY_16 = CmUtil.GetDataRowStr(dr, PosMst.MST_PAY_DC.DATA.APPR_VEND_CD);              // VAN 구분
                m_cPayItem.OCCUR_ENTRY_20 = GetPayDtlCdToPayDtlName(m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01);   // 결제수단명
                //m_cPayItem.CanFiller1 = sCardData;

                m_cPayItem.CANCEL_DIV = ItemConst.PAY_CANCEL_DIV.NORMAL;
                m_cPayItem.BILLSPR_NO = m_cTrnStatus.Sale.BillSplitNo;          // 빌분리 번호

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region 승인 실행
        /// <summary>
        /// 승인 실행
        /// </summary>
        private string ExecuteJsonIrt(string sTradeDiv, string sPAY_WAY_CD, string sPAY_DTL_CD_01, string sVanCD, string sTrType, string sInPutType, string sInPutData, string sInEncData, double nPayAmt, string sTransID, string sOrdTransID, string sApprNo, string sOrgPayID, ref Hashtable htRecvData)
        {
            string sServerIP = "";
            string sServerPort = ""; 
            int iRecvTimeOut = 60000;

            string sRet = UserCom.RST_ERR;

            try
            {
                // VAN 정보 조회
                sServerIP = "127.0.0.1";
                sServerPort = LF_GetPortRead();

                if (sServerPort.Trim() == "")
                {
                    WinManager.ErrorMessage(POS_MESSAGE.ERROR.MSG_0565);
                    return sRet;
                }

                // 전문 생성                
                string stSendData = MakeObjectJsonBody(sTradeDiv, sTrType, sInPutType, sInEncData, nPayAmt, sTransID, sOrdTransID, sApprNo, sOrgPayID);

                string sWriteSendData = CmUtil.MakeLogDataToMask(false, sInEncData, stSendData);
                UserLog.WriteLogFile(UserCom.LOG_SOCK, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                    "[SEND:" + sWriteSendData);
                // 요청 - 승인로그 저장   (판매구분, [0]결제수단, [1]결제상세코드, [2]전문구분, [3]요청구분, [4]카드번호, [5]결제금액, [6]승인번호, [7]승인일자, [8]승인시간, [9]응답상태값, [10]응답메시지, [11]전문)
                m_cDataCommon.SetSaleApprLog(sTradeDiv, new string[] { sPAY_WAY_CD, sPAY_DTL_CD_01, sTrType, "S", sInPutData, nPayAmt.ToString(), "", "", "", "", "", stSendData });

                // 전문 송수신 
                int iRet = m_cNetworkJson.ChinaIRTSendReceive(sServerIP, (int)CmUtil.IntParse(sServerPort), iRecvTimeOut, stSendData, ref htRecvData);

                if (iRet != BaseCom.OK)
                {
                    if (m_bErrMsgShow == true) WinManager.ErrorMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0158));
                    return sRet;
                }

                string sWriteRecvData = CmUtil.MakeLogDataToMask(false, sInEncData, JsonConvert.SerializeObject(htRecvData));
                UserLog.WriteLogFile(UserCom.LOG_SOCK, System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()",
                                    "[RECV:" + sWriteRecvData);

                // 응답 - 승인로그 저장   (판매구분, [0]결제수단, [1]결제상세코드, [2]전문구분, [3]요청구분, [4]카드번호, [5]결제금액, [6]승인번호, [7]승인일자, [8]승인시간, [9]응답상태값, [10]응답메시지, [11]전문)
                m_cDataCommon.SetSaleApprLog(sTradeDiv, new string[] { m_cPayItem.PAY_WAY_CD, m_cPayItem.PAY_DTL_CD_01, sTrType, "R"
                                                            , sInPutData, nPayAmt.ToString()
                                                            , "", DateTime.Now.ToString("yyyyMMdd"), DateTime.Now.ToString("HHmmss")
                                                            , htRecvData["statusCode"].ToString()
                                                            , ""
                                                            , JsonConvert.SerializeObject(htRecvData) });

                if (htRecvData["statusCode"].ToString() != "100")
                {
                    string sResMsg = "";
                    DataTable dtData = m_cDataCommon.SeletCommonCode(PosConst.COMMON_CODE_GROUP.Z0023, htRecvData["statusCode"].ToString());
                    if (dtData != null && dtData.Rows.Count > 0)
                    {
                        DataRow dr = dtData.Rows[0];
                        sResMsg = CmUtil.GetDataRowStr(dr, PosMst.MST_COMMON.DATA.CD_NM) + " (statusCode:" + htRecvData["statusCode"].ToString() + ")";
                    }
                    if (sResMsg.Trim() != "")
                        WinManager.ErrorMessage(sResMsg);
                    else
                        WinManager.ErrorMessage(MessageManager.GetErrorMessage(POS_MESSAGE.ERROR.MSG_0158) + " (statusCode:" + htRecvData["statusCode"].ToString() + ")");

                    sRet = UserCom.RST_ERR;
                    return sRet;
                }

                sRet = UserCom.RST_OK;
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                    System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                //여전법 대응!
                ////////////////////////////////////////////////////////////////////////////////// 
                CmUtil.ZeroFillClear(ref sInPutData);
                CmUtil.ZeroFillClear(ref sInEncData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sRet;
        }
        #endregion


        #region 요청 전문 바디 생성
        /// <summary>
        /// 요청 전문 바디 생성
        /// </summary>
        /// <param name="sTradeDiv"></param>
        /// <param name="sTrType"></param>
        /// <param name="sInPutType"></param>
        /// <param name="sInEncData"></param>
        /// <param name="nPayAmt"></param>
        /// <param name="sTransID"></param>
        /// <param name="sOrgTransID"></param>
        /// <param name="sApprNo"></param>
        /// <param name="sOrgPayID"></param>
        /// <returns></returns>
        protected string MakeObjectJsonBody(string sTradeDiv, string sTrType, string sInPutType, string sInEncData, double nPayAmt, string sTransID, string sOrgTransID, string sApprNo, string sOrgPayID)
        {
            string sSendData = string.Empty;
            JObject htHeader = new JObject();
            JObject joDatail = new JObject();

            try
            {
                if (sTradeDiv == PosConst.CANCEL_DIV.NORMAL)
                {
                    // 정상

                    // 상품정보
                    ArrayList aSaleItem = (ArrayList)StateObject.GetItemObject(Column.TR_PLU.ITEM);

                    //아이템 리스트 담기
                    JArray htDatail = new JArray();
                    htDatail = new JArray();

                    for (int iRow = 0; iRow < aSaleItem.Count; iRow++)
                    {
                        Column.TR_PLU.DATA cSaleItem = (Column.TR_PLU.DATA)aSaleItem[iRow];
                        if (cSaleItem.CANCEL_DIV == PosConst.CANCEL_DIV.CANCEL || cSaleItem.CANCEL_DIV_MAIN == PosConst.CANCEL_DIV.CANCEL) continue; // 지정취소

                        joDatail = new JObject(); 
                        joDatail.Add("consume_num", CmUtil.IntParse(cSaleItem.SALE_QTY.ToString()));        // 상품수량
                        // #Rhee, 20171121 중국 알리페이 전문 수정(판매금액->판매단가) start
                        // 기존
                        //joDatail.Add("price", CmUtil.IntParse((cSaleItem.SALE_AMT * 100).ToString()));      // 상품금액
                        // 변경
                        joDatail.Add("price", CmUtil.IntParse((cSaleItem.SALE_PRC * 100).ToString()));      // 상품금액
                        // #Rhee, 20171121 중국 알리페이 전문 수정(판매금액->판매단가) end
                        joDatail.Add("seq", iRow + 1);                                                      // 순번
                        joDatail.Add("pid", cSaleItem.ITEM_PLU_CD);                                         // 상품코드

                        htDatail.Add(joDatail);
                    }

                    // 결제정보
                    JArray jaTender = new JArray();
                    JObject joTender = new JObject();
                    jaTender = new JArray();
                    joTender = new JObject();

                    joTender.Add("amount", CmUtil.IntParse((nPayAmt * 100).ToString()));                    // 결제금액
                    joTender.Add("undis_amount", 0);                                                        // 할인 고정:0
                    joTender.Add("code", sInEncData);                                                       // 카드번호
                    joTender.Add("products", htDatail);                                                     // 상품정보 1개 이상 처리

                    jaTender.Add(joTender);


                    // 헤더정보
                    htHeader = new JObject();
                    htHeader.Add("ver", 2);                                                                 // 버전 고정2
                    htHeader.Add("operator_id", m_cPosStatus.Base.CashierNo);                               // 직원id
                    htHeader.Add("reqtype", CmUtil.IntParse(sTrType));                                      // 전문요청구분 (승인:72, 취소:62)
                    htHeader.Add("station_id", m_cPosStatus.Base.PosNo);                                    // PosNo
                    htHeader.Add("store_id", m_cPosStatus.Base.StoreNo);                                    // 점포코드
                    htHeader.Add("trans_id", sTransID);                                                     // 전송번호
                    htHeader.Add("business_date", m_cPosStatus.Base.SaleDate);                              // 거래일자
                    htHeader.Add("transactions", jaTender);                                                 // 트렌젝션 거래내역 1개 이상 처리
                }
                else  
                {
                    // 취소

                    // 결제정보
                    JArray jaTender = new JArray();
                    JObject joTender = new JObject();
                    jaTender = new JArray();
                    joTender = new JObject();

                    joTender.Add("paied_trans_id", sApprNo);                                                // 원 결제응답 고유번호
                    joTender.Add("paied_ebcode", CmUtil.IntParse(sOrgPayID));                               // 결제코드 (10001:알리페이, 10004:위챗페이)
                    joTender.Add("refund_count", CmUtil.IntParse((nPayAmt * 100).ToString()));              // 결제금액

                    jaTender.Add(joTender);

                    // 헤더정보
                    htHeader = new JObject();
                    htHeader.Add("ver", 1);                                                                 // 버전 고정2
                    htHeader.Add("refund_id", sTransID);                                                    // 전송번호
                    htHeader.Add("operator_id", m_cPosStatus.Base.CashierNo);                               // 직원id
                    htHeader.Add("reqtype", CmUtil.IntParse(sTrType));                                      // 전문요청구분 (승인:72, 취소:62)
                    htHeader.Add("station_id", m_cPosStatus.Base.PosNo);                                    // PosNo
                    htHeader.Add("store_id", m_cPosStatus.Base.StoreNo);                                    // 점포코드
                    htHeader.Add("trans_id", sOrgTransID);                                                  // 원전송번호
                    htHeader.Add("transactions", jaTender);                                                 // 트렌젝션 거래내역 1개 이상 처리
                }

                // 체크값 추가
                sSendData = LS_DataCheckSum(JsonConvert.SerializeObject(htHeader));

            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            finally
            {
                // 여전법 대응 ///////////////////////////////////////////////////////////////////
                CmUtil.ZeroFillClear(ref sInEncData);
                //////////////////////////////////////////////////////////////////////////////////
            }
            return sSendData;
        }
        #endregion

        #region 중국 알리페이/위챗페이 환경파일 읽기
        private string LF_GetPortRead()
        {
            string sRet = "";
            string sFileName = "fmclient.cfg";
            int iLineCount = 0;

            try
            {
                if (File.Exists(BaseCom.NxBinPath + sFileName))
                {
                    FileStream fs = new FileStream(BaseCom.NxBinPath + sFileName, FileMode.Open, FileAccess.Read);
                    StreamReader sr = new StreamReader(fs, Encoding.Default);

                    try
                    {
                        sr.BaseStream.Seek(0, SeekOrigin.Begin);

                        while (sr.Peek() > -1)
                        {
                            string sGetData = sr.ReadLine();
                            if (sGetData.Trim().Length == 0) continue;

                            if (iLineCount == 3)
                            {
                                // Port 번호 리턴
                                sRet = sGetData;
                                return sRet;
                            }
                            iLineCount++;
                        }
                    }
                    catch { }
                    finally
                    {
                        sr.Close();
                        fs.Close();
                    }
                }
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion

        #region 전송전문 체크 Sum
        private string LS_DataCheckSum(string sCheckData)
        {
            int nResult = 0;
            string sRet = "";

            try
            {
                if (sCheckData.Length <= 0) return "";

                // 마지막 } 문자 삭제후 ",  "추가
                string sTempData = sCheckData.Substring(0, sCheckData.Length - 1);
                sTempData += ", ";

                char[] cValues = sTempData.ToCharArray();
                int iCnt = 0;

                foreach (char cCheck in cValues)
                {
                    // '"', '\' 기호는 계산에서 제외
                    if (cCheck == '"') continue;
                    if (cCheck == '\'') continue;

                    // iCnt = 0, 1: +, 2: *, 3 - 
                    if (iCnt < 2)
                        nResult += Convert.ToInt32(cCheck);
                    else if (iCnt == 2)
                        nResult *= Convert.ToInt32(cCheck);
                    else  
                        nResult -= Convert.ToInt32(cCheck);

                    iCnt = (iCnt + 1) % 4;
                }

                // 마지막 체크값 추가
                sRet = sTempData + "\"checkValue\":" + nResult.ToString() + "}";
            }
            catch (Exception ex)
            {
                WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
                   System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
            }
            return sRet;
        }
        #endregion 

        //private string LS_ApprDeamon(bool bClose)
        //{
        //    string sRet = UserCom.RST_ERR;
        //    Process[] arPgm = null;
        //    try
        //    {
        //        if (bClose == true)
        //        {
        //            // 승인 데몬 종료
        //            arPgm = Process.GetProcessesByName("fmclient");
        //            foreach (Process pPgm in arPgm)
        //            {
        //                pPgm.Kill();
        //            }

        //            return UserCom.RST_OK;
        //        }
        //        else
        //        {
        //            // 승인 데몬 조회
        //            arPgm = Process.GetProcessesByName("fmclient");
        //            foreach (Process pPgm in arPgm)
        //            {
        //                return UserCom.RST_OK;
        //            }

        //            // 승인 데몬 실행
        //            ProcessStartInfo startInfo = new ProcessStartInfo(Directory.GetCurrentDirectory().ToString() + @"\fmclient.exe");
        //            startInfo.WindowStyle = ProcessWindowStyle.Hidden;
        //            startInfo.CreateNoWindow = false;
        //            Process.Start(startInfo);
                    
        //            sRet = UserCom.RST_OK;
        //        }
        //    }
        //    catch (Exception ex)
        //    {
        //        WinManager.ExceptionMessage(System.Reflection.Assembly.GetExecutingAssembly().ManifestModule.Name,
        //           System.Reflection.MethodBase.GetCurrentMethod().DeclaringType.Name + "." + System.Reflection.MethodBase.GetCurrentMethod().Name + "()", ex.Message);
        //    }
        //    return sRet;
        //}
    }
}
